]> diplodocus.org Git - nmh/blobdiff - test/scan/test-scan-multibyte
Removed myuid and mygid variables, they're no longer used and
[nmh] / test / scan / test-scan-multibyte
index 1e9349a09163476e360554be40aae00b856a5bbc..98dd9a2608248e98f6a1bd43406ac707f9a1a1ae 100755 (executable)
@@ -47,7 +47,7 @@ Subject: =?utf-8?q?Sp=C4=B1n=CC=88al_Tap_=E2=86=92_Tap_into_America!?=
 Things are looking great!
 EOF
 
 Things are looking great!
 EOF
 
-width=`${MH_OBJ_DIR}/test/getcwidth`
+width=`${MH_OBJ_DIR}/test/getcwidth "→n̈"`
 if test $? -ne 0; then
     echo "getcwidth failed to run"
     exit 1
 if test $? -ne 0; then
     echo "getcwidth failed to run"
     exit 1
@@ -56,23 +56,29 @@ fi
 expected="$MH_TEST_DIR/$$.expected"
 actual="$MH_TEST_DIR/$$.actual"
 
 expected="$MH_TEST_DIR/$$.expected"
 actual="$MH_TEST_DIR/$$.actual"
 
-if test "$width" -eq 1; then
+if test "$width" -eq 3; then
 cat > "$expected" <<EOF
   11  03/02 David st Hubbins    Spın̈al Tap → Tap into America!<<Things are look
 EOF
 cat > "$expected" <<EOF
   11  03/02 David st Hubbins    Spın̈al Tap → Tap into America!<<Things are look
 EOF
-elif test "$width" -eq 0; then
+elif test "$width" -eq 2; then
 cat > "$expected" <<EOF
   11  03/02 David st Hubbins    Spın̈al Tap → Tap into America!<<Things are looki
 EOF
 else
 cat > "$expected" <<EOF
   11  03/02 David st Hubbins    Spın̈al Tap → Tap into America!<<Things are looki
 EOF
 else
-    echo "Unsupported width for combining diaeresis: $width"
+    echo "Unsupported width for UTF-8 test string: $width"
     exit 1
 fi
 
 scan -width 80 +inbox 11 > $actual || exit 1
 check "$expected" "$actual"
 
     exit 1
 fi
 
 scan -width 80 +inbox 11 > $actual || exit 1
 check "$expected" "$actual"
 
-# check decoding with an invalid multibyte sequence
+#
+# Check decoding with an invalid multibyte sequence.  We skip this test
+# if we don't have iconv support, since it requires converting from one
+# character set to another.  Be sure we created the test file, though, because
+# it's required for the test right after it.
+#
+
 cat >`mhpath new` <<EOF
 From: Test12 <test12@example.com>
 To: Some User <user@example.com>
 cat >`mhpath new` <<EOF
 From: Test12 <test12@example.com>
 To: Some User <user@example.com>
@@ -89,13 +95,34 @@ cat >"$expected" <<EOF
   12  12/31 Test12             2013 New Year?s Deals! Start the year right
 EOF
 
   12  12/31 Test12             2013 New Year?s Deals! Start the year right
 EOF
 
-LC_CTYPE=ISO-8859-1 MM_CHARSET=ISO-8859-1 scan -width 75 last >"$actual"
-check "$expected" "$actual"
+if test "$ICONV_ENABLED" -eq 1; then
+    LC_CTYPE=ISO-8859-1 MM_CHARSET=ISO-8859-1 scan -width 75 last >"$actual"
+    check "$expected" "$actual"
+fi
+
+#
+# Find out the width of our Unicode apostrophe (U+2019).  Some implementations
+# say it has a width of 2, but that seems totally bizarre to me.
+#
+
+width=`${MH_OBJ_DIR}/test/getcwidth U+2019`
+if test $? -ne 0; then
+    echo "getcwidth failed to run"
+    exit 1
+fi
 
 # check scan width with a valid multibyte sequence
 
 # check scan width with a valid multibyte sequence
-cat >"$expected" <<EOF
+if test "$width" -eq 1; then
+    cat >"$expected" <<EOF
   12  12/31 Test12             2013 New Year’s Deals! Start the year right
 EOF
   12  12/31 Test12             2013 New Year’s Deals! Start the year right
 EOF
+elif test "$width" -eq 2; then
+    cat >"$expected" <<EOF
+  12  12/31 Test12             2013 New Year’s Deals! Start the year righ
+EOF
+else
+    echo "Unsupported width for U+2019: $width"
+fi
 
 LC_CTYPE=en_US.UTF-8 MM_CHARSET=UTF-8 scan -width 75 last >"$actual"
 check "$expected" "$actual"
 
 LC_CTYPE=en_US.UTF-8 MM_CHARSET=UTF-8 scan -width 75 last >"$actual"
 check "$expected" "$actual"